package productlogic

import (
	"code.30cm.net/digimon/app-cloudep-product-service/gen_result/pb/product"
	"code.30cm.net/digimon/app-cloudep-product-service/internal/svc"
	"code.30cm.net/digimon/app-cloudep-product-service/pkg/domain/entity"
	"code.30cm.net/digimon/app-cloudep-product-service/pkg/domain/kyc"
	"context"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateKYCLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewCreateKYCLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateKYCLogic {
	return &CreateKYCLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *CreateKYCLogic) CreateKYC(in *product.CreateKYCReq) (*product.OKResp, error) {
	err := l.svcCtx.KYCUseCase.Create(l.ctx, &entity.KYC{
		UID:                in.GetUid(),
		CountryRegion:      in.GetCountryRegion(),
		Name:               in.GetName(),
		Identification:     in.GetIdentification(),
		IdentificationType: in.GetIdentificationType(),
		Address:            in.GetAddress(),
		PostalCode:         in.GetPostalCode(),
		IDFrontImage:       in.GetIdFrontImage(),
		IDBackImage:        in.GetIdBackImage(),
		BankStatementImg:   in.GetBankStatementImg(),
		BankCode:           in.GetBankCode(),
		BankName:           in.GetName(),
		BranchCode:         in.GetBranchCode(),
		BranchName:         in.GetBranchName(),
		BankAccount:        in.GetBankAccount(),
		Status:             kyc.StatusPending,
		RejectReason:       "",
	})
	if err != nil {
		return nil, err
	}

	return &product.OKResp{}, nil
}
