package utils

import (
	"encoding/base64"

	"github.com/golang/snappy"
)

// EncodeToBase64Snappy 將字串進行 Base64 和 Snappy 編碼
func EncodeToBase64Snappy(data string) string {
	snappyData := snappy.Encode(nil, []byte(data))
	encoded := base64.StdEncoding.EncodeToString(snappyData)

	return encoded
}

// DecodeToBase64Snappy 將字串進行 Base64 和 Snappy 解碼
func DecodeToBase64Snappy(data string) string {
	decodeB64Content, _ := base64.StdEncoding.DecodeString(data)
	snappyContent, _ := snappy.Decode(nil, decodeB64Content)

	return string(snappyContent)
}
